    ;void alureg_copy(int len, int num_times_to_repeat, int* x, int* y);
    ; 
    ; TO ASSEMBLE INTO *.obj DO THE FOLLOWING:
    ; ml.exe -coff -c alureg_copy.asm
    ;
    .586
    .K3D
    .XMM
    _TEXT SEGMENT 
    PUBLIC _alureg_copy 
    _alureg_copy PROC NEAR
    ;===================================================================================================
    ;INSTRUCTIONS BELOW SAVE THE REGISTER STATE WITH WHICH THIS ROUTINE WAS ENTERED
    ;    REGISTERS (eax, ecx, edx are considered volatile and assumed to be changed)
    ;    WHILE THE REGISTERS BELOW MUST BE PRESERVED IF THE USER IS CHANGING THEM
    push ebp
    mov ebp,esp
    ;===================================================================================================
    ; parameters passed into routine:
    ; [ebp+8] = len (number of bytes to be copied)
    ; [ebp+12] = num_times_to_repeat
    ; [ebp+16] = ->x
    ; [ebp+20] = ->y
    ;===================================================================================================
    push eax
    push ebx
    push ecx
    push edx
    push esi
    push edi
    ;===================================================================================================
    mov ecx,[ebp+8]  ; ecx = # of bytes to copy from x[] to y[]
    mov eax,[ebp+12] ; eax = number of times to perform "rep movsd" copy
    mov esi,[ebp+16] ; esi = ->"x"
    mov edi,[ebp+20] ; edi = ->"y"
    add esi,ecx      ; esi ->the end of the last element of x to be copied
    add edi,ecx      ; edi ->the end of the last element of y to be copied
    shr ecx,2        ; divide the number of bytes to copy by 4 to figure
                     ;    out how many double words are to be copied from
                     ;    x[] to y[]
    neg ecx          ;
    align 16         ; align instructions to 16 byte boundary
    ;===================================================================================================
    repeat_measurement:    ; loop over the vector copy by "num_times_to_repeat" times
        pushad             ; push all the 32 bit registers onto the stack
        ;================================================================================================
        bytecopyloop:                ; copy 128 bytes of x[] to y[] with each pass through the code below
            mov eax,[esi+4*ecx]      ; eax = x[0]
            mov ebx,[esi+4*ecx+4]    ; ebx = x[1]
            mov edx,[esi+4*ecx+8]    ; edx = x[2]
            mov ebp,[esi+4*ecx+12]   ; ebp = x[3]
            mov [edi+4*ecx],eax      ; y[0] = x[0]
            mov [edi+4*ecx+4],ebx    ; y[1] = x[1]
            mov [edi+4*ecx+8],edx    ; y[2] = x[2]
            mov [edi+4*ecx+12],ebp   ; y[3] = x[3]
            mov eax,[esi+4*ecx+16]   ; eax = x[4]
            mov ebx,[esi+4*ecx+20]   ; ebx = x[5]
            mov edx,[esi+4*ecx+24]   ; edx = x[6]
            mov ebp,[esi+4*ecx+28]   ; ebp = x[7]
            mov [edi+4*ecx+16],eax   ; y[4] = x[4]
            mov [edi+4*ecx+20],ebx   ; y[5] = x[5]
            mov [edi+4*ecx+24],edx   ; y[6] = x[6]
            mov [edi+4*ecx+28],ebp   ; y[7] = x[7]
            mov eax,[esi+4*ecx+32]   ; eax = x[8]
            mov ebx,[esi+4*ecx+36]   ; ebx = x[9]
            mov edx,[esi+4*ecx+40]   ; edx = x[10]
            mov ebp,[esi+4*ecx+44]   ; ebp = x[11]
            mov [edi+4*ecx+32],eax   ; y[8] = x[8]
            mov [edi+4*ecx+36],ebx   ; y[9] = x[9]
            mov [edi+4*ecx+40],edx   ; y[10] = x[10]
            mov [edi+4*ecx+44],ebp   ; y[11] = x[11]
            mov eax,[esi+4*ecx+48]   ; eax = x[12]
            mov ebx,[esi+4*ecx+52]   ; ebx = x[13]
            mov edx,[esi+4*ecx+56]   ; edx = x[14]
            mov ebp,[esi+4*ecx+60]   ; ebp = x[15]
            mov [edi+4*ecx+48],eax   ; y[12] = x[12]
            mov [edi+4*ecx+52],ebx   ; y[13] = x[13]
            mov [edi+4*ecx+56],edx   ; y[14] = x[14]
            mov [edi+4*ecx+60],ebp   ; y[15] = x[15]
            mov eax,[esi+4*ecx+64]   ; eax = x[16]
            mov ebx,[esi+4*ecx+68]   ; ebx = x[17]
            mov edx,[esi+4*ecx+72]   ; edx = x[18]
            mov ebp,[esi+4*ecx+76]   ; ebp = x[19]
            mov [edi+4*ecx+64],eax   ; y[16] = x[16]
            mov [edi+4*ecx+68],ebx   ; y[17] = x[17]
            mov [edi+4*ecx+72],edx   ; y[18] = x[18]
            mov [edi+4*ecx+76],ebp   ; y[19] = x[19]
            mov eax,[esi+4*ecx+80]   ; eax = x[20]
            mov ebx,[esi+4*ecx+84]   ; ebx = x[21]
            mov edx,[esi+4*ecx+88]   ; edx = x[22]
            mov ebp,[esi+4*ecx+92]   ; ebp = x[23]
            mov [edi+4*ecx+80],eax   ; y[20] = x[20]
            mov [edi+4*ecx+84],ebx   ; y[21] = x[21]
            mov [edi+4*ecx+88],edx   ; y[22] = x[22]
            mov [edi+4*ecx+92],ebp   ; y[23] = x[23]
            mov eax,[esi+4*ecx+96]   ; eax = x[24]
            mov ebx,[esi+4*ecx+100]  ; ebx = x[25]
            mov edx,[esi+4*ecx+104]  ; edx = x[26]
            mov ebp,[esi+4*ecx+108]  ; ebp = x[27]
            mov [edi+4*ecx+96],eax   ; y[24] = x[24]
            mov [edi+4*ecx+100],ebx  ; y[25] = x[25]
            mov [edi+4*ecx+104],edx  ; y[26] = x[26]
            mov [edi+4*ecx+108],ebp  ; y[27] = x[27]
            mov eax,[esi+4*ecx+112]  ; eax = x[28]
            mov ebx,[esi+4*ecx+116]  ; ebx = x[29]
            mov edx,[esi+4*ecx+120]  ; edx = x[30]
            mov ebp,[esi+4*ecx+124]  ; ebp = x[31]
            mov [edi+4*ecx+112],eax  ; y[28] = x[28]
            mov [edi+4*ecx+116],ebx  ; y[29] = x[29]
            mov [edi+4*ecx+120],edx  ; y[30] = x[30]
            mov [edi+4*ecx+124],ebp  ; y[31] = x[31]
            add ecx,32
        js bytecopyloop
        ;===============================================================================================
        popad              ; pop old 32 bit register values off the stack
        dec eax            ; decrement the # of times to repeat copy test
                           ;    if eax =0 then the zero flags bit is set. 
    jnz repeat_measurement ; if the bit is not set then loop back above to 
                           ;    "repeating:" address and repeat instructions between
                           ;    "repeating:" and "jnz repeating"
    ;===================================================================================================

    ;===================================================================================================
    ;INSTRUCTIONS BELOW RESTORE THE REGISTER STATE WITH WHICH THIS ROUTINE WAS ENTERED
    ;    REGISTERS (eax, ecx, edx are considered volatile and assumed to be changed)
    ;    WHILE THE REGISTERS BELOW MUST BE PRESERVED IF THE USER IS CHANGING THEM
    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx
    pop eax
    mov esp,ebp
    pop ebp
    ;=================================================================================================== 
    ;
    ret
    _alureg_copy ENDP
    _TEXT ENDS
    END

