    ;void repmovsd_copy(int len, int num_times_to_repeat, int* x, int* y);
    ; 
    ; TO ASSEMBLE INTO *.obj DO THE FOLLOWING:
    ; ml.exe -coff -c repmovsd_copy.asm
    ;
    .586
    .K3D
    .XMM
    _TEXT SEGMENT 
    PUBLIC _repmovsd_copy 
    _repmovsd_copy PROC NEAR
    ;===================================================================================================
    ;INSTRUCTIONS BELOW SAVE THE REGISTER STATE WITH WHICH THIS ROUTINE WAS ENTERED
    ;    REGISTERS (eax, ecx, edx are considered volatile and assumed to be changed)
    ;    WHILE THE REGISTERS BELOW MUST BE PRESERVED IF THE USER IS CHANGING THEM
    push ebp
    mov ebp,esp
    ;===================================================================================================
    ; parameters passed into routine:
    ; [ebp+8] = len (number of bytes to be copied)
    ; [ebp+12] = num_times_to_repeat
    ; [ebp+16] = ->x
    ; [ebp+20] = ->y
    ;===================================================================================================
    push eax
    push ebx
    push ecx
    push edx
    push esi
    push edi
    ;===================================================================================================
    ; Beginning of source code for "rep movsd" copy
    ;===================================================================================================
    mov ecx,[ebp+8]     ; ecx = len
    mov eax,[ebp+12]    ; eax = number of times to perform "rep movsd" copy
    mov esi,[ebp+16]    ; esi = ->"x"
    mov edi,[ebp+20]    ; edi = ->"y"
    shr ecx,2           ; divide the number of bytes to copy by 4 so as 
                        ; to figure out the # of double words to be copied
    align 16            ; align instructions to 16 byte boundary
    ;===================================================================================================
    repeating:          ; loop over the vector copy by "num_times_to_repeat" times
        pushad          ; push all the 32 bit registers onto the stack
        rep movsd       ; mov [esi] ==> [edi] and increment both addresses
        popad           ; pop old 32 bit register values off the stack
        dec eax         ; decrement the # of times to repeat copy test
    jnz repeating       ; if eax =0 then the zero flags bit is set. 
    ;===================================================================================================
    ; if the bit is not set then loop back above to 
    ;    "repeating:" address and repeat instructions between
    ;    "repeating:" and "jnz repeating"
    ;===================================================================================================
    ;INSTRUCTIONS BELOW RESTORE THE REGISTER STATE WITH WHICH THIS ROUTINE WAS ENTERED
    ;    REGISTERS (eax, ecx, edx are considered volatile and assumed to be changed)
    ;    WHILE THE REGISTERS BELOW MUST BE PRESERVED IF THE USER IS CHANGING THEM
    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx
    pop eax
    mov esp,ebp
    pop ebp
    ;=================================================================================================== 
    ;
    ret
    _repmovsd_copy ENDP
    _TEXT ENDS
    END

