; SEH code is incomplete and buggy...
; The MMX_blk_pref_4KB routine is broken and disabled...

include masm32rt.inc    ; masm32 v9.00 compile-time libs
.686
.MMX
.K3D
.XMM
include proctimers.inc  ; Petroizki's excellent proc timer routine
include membench.inc    ; all the ScienceMark memory copy routines

ErrorHandler	PROTO C	:DWORD,:DWORD,:DWORD,:DWORD
ExceptionFilter	PROTO	:DWORD

.data
    szSrc       db  "This is a source string. It is 512 bytes long. That should"
                db  " be long enough to get an adequate timing result for these"
                db  " memory copy routines. Petrozki made the timing routines"
                db  " proctimers.inc and ptimers.inc - they work very well."
                db  " We should probably make some kind of reference to my"
                db  " brother Darryl here, but he gets too much publicity as"
                db  " it is. We could talk about the price of eggs in China"
                db  " instead, but who would care about that? We'd better"
                db  " get busy with the rest of our code here. Thanks for"
                db  " reading, have fun!",0
    szDst       db  512 dup(0)
    szInt       db  16 dup(0)
    szProc      db  " Processor: ",0
    szCPU       db  48 dup(0)
    hStdOut     dd  0
    seh         dd  3 dup(0)
    err         dd  0

    SrcLen    equ (szDst - szSrc)     ; this returns the exact length of
                                        ; szSrc whereas SIZEOF does not!
.code
start:
    invoke GetStdHandle,STD_OUTPUT_HANDLE
    mov hStdOut,eax
    print chr$(" ScienceMark 512-byte memory copy timings 2006 by MarkJ.",13,10)

    mov eax,80000000h                       ; by Petrozski
    cpuid                                   ; original from MichaelW
    cmp eax,80000004h                       ; probably from Agner Fog
    jb @nocpuid
    mov eax,80000002h
    cpuid
    mov dword ptr [szCPU+00],eax            ; concatinate CPUID strings
    mov dword ptr [szCPU+04],ebx
    mov dword ptr [szCPU+08],ecx
    mov dword ptr [szCPU+12],edx
    mov eax,80000003h
    cpuid
    mov dword ptr [szCPU+16],eax
    mov dword ptr [szCPU+20],ebx
    mov dword ptr [szCPU+24],ecx
    mov dword ptr [szCPU+28],edx
    mov eax,80000004h
    cpuid
    mov dword ptr [szCPU+32],eax
    mov dword ptr [szCPU+36],ebx
    mov dword ptr [szCPU+40],ecx
    mov dword ptr [szCPU+44],edx

    print addr szProc
    print addr szCPU,13,10,13,10
@nocpuid:

; setup error handler
    invoke SetUnhandledExceptionFilter,addr ExceptionFilter
    
; benchmark each routine, handling any exceptions
    print chr$(" repmovsd_copy:      ")     ; 196 nominal
    PTIMER_PROC_LOOP_COUNT repmovsd_copy,addr szDst,addr szSrc,SrcLen
    call disp
    print chr$(" alu_reg_copy:       ")     ; 172 nominal
    PTIMER_PROC_LOOP_COUNT alu_reg_copy,addr szDst,addr szSrc,SrcLen
    call disp
    print chr$(" MMX_copy:           ")     ; 111 nominal
    PTIMER_PROC_LOOP_COUNT MMX_copy,addr szDst,addr szSrc,SrcLen
    call disp
    print chr$(" MMX_blk_pref_4KB:   ")     ; ERROR nominal
    ;PTIMER_PROC_LOOP_COUNT MMX_blk_pref_4KB,addr szDst,addr szSrc,SrcLen
    ;call disp
    call error
    print chr$(" MMX_blk_pref_16KB:  ")     ; 321 nominal
    PTIMER_PROC_LOOP_COUNT MMX_blk_pref_16KB,addr szDst,addr szSrc,SrcLen
    call disp
    print chr$(" MMXw3DNowPref_copy: ")     ; 125 nominal
    PTIMER_PROC_LOOP_COUNT MMXw3DNowPref_copy,addr szDst,addr szSrc,SrcLen
    call disp
    print chr$(" MMXwSSEPref_copy:   ")     ; 125 nominal
    PTIMER_PROC_LOOP_COUNT MMXwSSEPref_copy,addr szDst,addr szSrc,SrcLen
    call disp
    print chr$(" SSE_copy:           ")     ; 160 nominal
    PTIMER_PROC_LOOP_COUNT SSE_copy,addr szDst,addr szSrc,SrcLen
    call disp
    print chr$(" SSE_blk_prf_4KB:    ")     ; 214 nominal
    PTIMER_PROC_LOOP_COUNT SSE_blk_prf_4KB,addr szDst,addr szSrc,SrcLen
    call disp
    print chr$(" SSE_blk_prf_16KB:   ")     ; 214 nominal
    PTIMER_PROC_LOOP_COUNT SSE_blk_prf_16KB,addr szDst,addr szSrc,SrcLen
    call disp
    print chr$(" SSEwPref_copy:      ")     ; 168 nominal
    PTIMER_PROC_LOOP_COUNT SSEwPref_copy,addr szDst,addr szSrc,SrcLen
    call disp
    print chr$(" SSE2_copy:          ")     ; 59 nominal
    PTIMER_PROC_LOOP_COUNT SSE2_copy,addr szDst,addr szSrc,SrcLen
    call disp
    print chr$(" SSE2wPref_copy:     ")     ; 65 nominal
    PTIMER_PROC_LOOP_COUNT SSE2wPref_copy,addr szDst,addr szSrc,SrcLen
    call disp

; remove error handler
    invoke SetUnhandledExceptionFilter,NULL
; exit
    mov eax,input(13,10," Press ENTER to exit...")
    invoke CloseHandle,hStdOut
    invoke ExitProcess,0    


disp proc
    invoke dwtoa,dword ptr [qwPROCTIMER_RESULT],addr szInt
    print offset szInt
    print chr$(" cycles")
    invoke lstrcmp,addr szDst,addr szSrc
    .if eax!=0
        print chr$(", FAILS COMPARE!")
    .endif
    print chr$(13,10)
    mov dword ptr [szDst],0     ; invalidate dest
    mov err,0                   ; reset any errors
    ret
disp endp

error proc
    print chr$("ERROR",13,10)
    ret
error endp


ErrorHandler proc C lpExcept:DWORD,lpFrame:DWORD,lpContext:DWORD,lpDispatch:DWORD
	; message about the exception
	mov	eax, [lpExcept]
;invoke	wsprintf, ADDR szMessage, ADDR szErrorThread, [eax][EXCEPTION_RECORD.ExceptionAddress]
invoke Beep,100,500
	;invoke	MessageBox, [mbp.hwndOwner], ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL

	; the standard way to recover
	mov	eax, [lpContext]
	m2m	[eax][CONTEXT.regEsp], [seh]
	m2m	[eax][CONTEXT.regEbp], [seh+4]
	m2m	[eax][CONTEXT.regEip], [seh+8]

	; another way to recover
	;mov	esp, [seh]
	;mov	ebp, [seh+4]
	;jmp	[seh+8]

	xor	eax, eax	; continue execution
	ret
ErrorHandler endp


ExceptionFilter proc lpExcept:DWORD
	; note: EXCEPTION_RECORD contains a pointer to the next EXCEPTION_RECORD
	;       structure named pExceptionRecord. The real address of the exception
	;       in your application will be somewhere in the chain.
	;       This piece of code will merely tell the address of the topmost
	;       EXCEPTION_RECORD in the chain.
	mov	eax, [lpExcept]
;invoke	wsprintf, ADDR szMessage, ADDR szErrorFinal, [eax][EXCEPTION_RECORD.ExceptionAddress]
;invoke Beep,200,500
.if err==0
    call error
    add err,1
.endif

	;invoke	MessageBox, [mbp.hwndOwner], ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL
	; clean-up and quit
	;invoke	EndDialog, [mbp.hwndOwner], eax
	;invoke	DestroyIcon, [hIcon]
    ;invoke	ExitProcess, 0
	;xor	eax, eax
	;inc	eax		; EXCEPTION_EXECUTE_HANDLER
	;mov eax,EXCEPTION_EXECUTE_HANDLER
	mov eax,EXCEPTION_CONTINUE_EXECUTION
	;mov eax,EXCEPTION_CONTINUE_SEARCH
	ret

; The filter function should return one of the following values: 
; 
; Value	                        Meaning
; EXCEPTION_EXECUTE_HANDLER	- Return from UnhandledExceptionFilter and execute the 
;    associated exception handler. This usually results in process termination.
; EXCEPTION_CONTINUE_EXECUTION - Return from UnhandledExceptionFilter and 
;    continue execution from the point of the exception. Note that the filter 
;    function is free to modify the continuation state by modifying the exception 
;    information supplied through its LPEXCEPTION_POINTERS parameter.
; EXCEPTION_CONTINUE_SEARCH	- Proceed with normal execution of 
; UnhandledExceptionFilter. That means obeying the SetErrorMod flags, or 
; invoking the Application Error pop-up message box.
ExceptionFilter endp


end start

