; all these routines were adapted from code publically available at
; http://www.sciencemark.org/bench/membench/intro.html
repmovsd_copy       proto :DWORD,:DWORD,:DWORD
alu_reg_copy        proto :DWORD,:DWORD,:DWORD
MMX_copy            proto :DWORD,:DWORD,:DWORD
MMX_blk_pref_4KB    proto :DWORD,:DWORD,:DWORD
MMX_blk_pref_16KB   proto :DWORD,:DWORD,:DWORD
MMXw3DNowPref_copy  proto :DWORD,:DWORD,:DWORD
MMXwSSEPref_copy    proto :DWORD,:DWORD,:DWORD
SSE_copy            proto :DWORD,:DWORD,:DWORD
SSE_blk_prf_4KB     proto :DWORD,:DWORD,:DWORD
SSE_blk_prf_16KB    proto :DWORD,:DWORD,:DWORD
SSEwPref_copy       proto :DWORD,:DWORD,:DWORD
SSE2_copy           proto :DWORD,:DWORD,:DWORD
SSE2wPref_copy      proto :DWORD,:DWORD,:DWORD


repmovsd_copy  proc uses esi edi dst:DWORD,src:DWORD,Len:DWORD 
    
    mov ecx,Len         ; ecx = len
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"
    shr ecx,2           ; divide the number of bytes to copy by 4 so as 
                        ; to figure out the # of double words to be copied
    align 16            ; align instructions to 16 byte boundary
    rep movsd           ; mov [esi] ==> [edi] and increment both addresses
    ret
repmovsd_copy endp


alu_reg_copy proc uses ebx esi edi ebp dst:DWORD,src:DWORD,Len:DWORD
    
    mov ecx,Len      ; ecx = len
    mov esi,src      ; esi = ->"x"
    mov edi,dst      ; edi = ->"y"
    add esi,ecx      ; esi ->the end of the last element of x to be copied
    add edi,ecx      ; edi ->the end of the last element of y to be copied
    shr ecx,2        ; divide the number of bytes to copy by 4 to figure
                     ; out how many double words are to be copied
    neg ecx          ;
align 16             ; align loop to 16-byte boundary
bytecopyloop:                    ; copy 128 bytes of x[] to y[]
        mov eax,[esi+4*ecx]      ; eax = x[0]
        mov ebx,[esi+4*ecx+4]    ; ebx = x[1]
        mov edx,[esi+4*ecx+8]    ; edx = x[2]
        mov ebp,[esi+4*ecx+12]   ; ebp = x[3]
        mov [edi+4*ecx],eax      ; y[0] = x[0]
        mov [edi+4*ecx+4],ebx    ; y[1] = x[1]
        mov [edi+4*ecx+8],edx    ; y[2] = x[2]
        mov [edi+4*ecx+12],ebp   ; y[3] = x[3]
        mov eax,[esi+4*ecx+16]   ; eax = x[4]
        mov ebx,[esi+4*ecx+20]   ; ebx = x[5]
        mov edx,[esi+4*ecx+24]   ; edx = x[6]
        mov ebp,[esi+4*ecx+28]   ; ebp = x[7]
        mov [edi+4*ecx+16],eax   ; y[4] = x[4]
        mov [edi+4*ecx+20],ebx   ; y[5] = x[5]
        mov [edi+4*ecx+24],edx   ; y[6] = x[6]
        mov [edi+4*ecx+28],ebp   ; y[7] = x[7]
        mov eax,[esi+4*ecx+32]   ; eax = x[8]
        mov ebx,[esi+4*ecx+36]   ; ebx = x[9]
        mov edx,[esi+4*ecx+40]   ; edx = x[10]
        mov ebp,[esi+4*ecx+44]   ; ebp = x[11]
        mov [edi+4*ecx+32],eax   ; y[8] = x[8]
        mov [edi+4*ecx+36],ebx   ; y[9] = x[9]
        mov [edi+4*ecx+40],edx   ; y[10] = x[10]
        mov [edi+4*ecx+44],ebp   ; y[11] = x[11]
        mov eax,[esi+4*ecx+48]   ; eax = x[12]
        mov ebx,[esi+4*ecx+52]   ; ebx = x[13]
        mov edx,[esi+4*ecx+56]   ; edx = x[14]
        mov ebp,[esi+4*ecx+60]   ; ebp = x[15]
        mov [edi+4*ecx+48],eax   ; y[12] = x[12]
        mov [edi+4*ecx+52],ebx   ; y[13] = x[13]
        mov [edi+4*ecx+56],edx   ; y[14] = x[14]
        mov [edi+4*ecx+60],ebp   ; y[15] = x[15]
        mov eax,[esi+4*ecx+64]   ; eax = x[16]
        mov ebx,[esi+4*ecx+68]   ; ebx = x[17]
        mov edx,[esi+4*ecx+72]   ; edx = x[18]
        mov ebp,[esi+4*ecx+76]   ; ebp = x[19]
        mov [edi+4*ecx+64],eax   ; y[16] = x[16]
        mov [edi+4*ecx+68],ebx   ; y[17] = x[17]
        mov [edi+4*ecx+72],edx   ; y[18] = x[18]
        mov [edi+4*ecx+76],ebp   ; y[19] = x[19]
        mov eax,[esi+4*ecx+80]   ; eax = x[20]
        mov ebx,[esi+4*ecx+84]   ; ebx = x[21]
        mov edx,[esi+4*ecx+88]   ; edx = x[22]
        mov ebp,[esi+4*ecx+92]   ; ebp = x[23]
        mov [edi+4*ecx+80],eax   ; y[20] = x[20]
        mov [edi+4*ecx+84],ebx   ; y[21] = x[21]
        mov [edi+4*ecx+88],edx   ; y[22] = x[22]
        mov [edi+4*ecx+92],ebp   ; y[23] = x[23]
        mov eax,[esi+4*ecx+96]   ; eax = x[24]
        mov ebx,[esi+4*ecx+100]  ; ebx = x[25]
        mov edx,[esi+4*ecx+104]  ; edx = x[26]
        mov ebp,[esi+4*ecx+108]  ; ebp = x[27]
        mov [edi+4*ecx+96],eax   ; y[24] = x[24]
        mov [edi+4*ecx+100],ebx  ; y[25] = x[25]
        mov [edi+4*ecx+104],edx  ; y[26] = x[26]
        mov [edi+4*ecx+108],ebp  ; y[27] = x[27]
        mov eax,[esi+4*ecx+112]  ; eax = x[28]
        mov ebx,[esi+4*ecx+116]  ; ebx = x[29]
        mov edx,[esi+4*ecx+120]  ; edx = x[30]
        mov ebp,[esi+4*ecx+124]  ; ebp = x[31]
        mov [edi+4*ecx+112],eax  ; y[28] = x[28]
        mov [edi+4*ecx+116],ebx  ; y[29] = x[29]
        mov [edi+4*ecx+120],edx  ; y[30] = x[30]
        mov [edi+4*ecx+124],ebp  ; y[31] = x[31]
        add ecx,32
    js bytecopyloop
    ret
alu_reg_copy endp


MMX_copy proc uses esi edi dst:DWORD,src:DWORD,Len:DWORD
    
    emms                ; empty mmx state
    mov ecx,Len         ; ecx = # of bytes to copy from x[] to y[]
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"
    add esi,ecx         ; esi ->the end of the last element of x to be copied
    add edi,ecx         ; edi ->the end of the last element of y to be copied
    shr ecx,3           ; divide the number of bytes to copy by 8 to figure
                        ; out how many quad words are to be copied
    neg ecx             ;
align 16                ; align instructions to 16 byte boundary
bytecopyloop:                    ; copy 128 bytes of x[] to y[] with each pass
        movq mm0,[esi+8*ecx]     ; mmx0 = [x(1),x(0)]
        movq mm1,[esi+8*ecx+8]   ; mmx1 = [x(3),x(2)]
        movq mm2,[esi+8*ecx+16]  ; mmx2 = [x(5),x(4)]
        movq mm3,[esi+8*ecx+24]  ; mmx3 = [x(7),x(6)]
        movq [edi+8*ecx],mm0     ; [y(1),y(0)] = [x(1),x(0)]
        movq [edi+8*ecx+8],mm1   ; [y(3),y(2)] = [x(3),x(2)]
        movq [edi+8*ecx+16],mm2  ; [y(5),x(4)] = [x(5),x(4)]
        movq [edi+8*ecx+24],mm3  ; [y(7),y(6)] = [x(7),x(6)]
        movq mm4,[esi+8*ecx+32]  ; mmx4 = [x(9),x(8)]
        movq mm5,[esi+8*ecx+40]  ; mmx5 = [x(11),x(10)]
        movq mm6,[esi+8*ecx+48]  ; mmx6 = [x(13),x(12)]
        movq mm7,[esi+8*ecx+56]  ; mmx7 = [x(15),x(14)]
        movq [edi+8*ecx+32],mm4  ; [y(9),y(8)] = [x(9),x(8)]
        movq [edi+8*ecx+40],mm5  ; [y(11),y(10)] = [x(11),x(10)]
        movq [edi+8*ecx+48],mm6  ; [y(13),y(12)] = [x(13),x(12)]
        movq [edi+8*ecx+56],mm7  ; [y(15),y(14)] = [x(15),x(14)]
        movq mm0,[esi+8*ecx+64]  ; mmx0 = [x(17),x(16)]
        movq mm1,[esi+8*ecx+72]  ; mmx1 = [x(19),x(18)]
        movq mm2,[esi+8*ecx+80]  ; mmx2 = [x(21),x(20)]
        movq mm3,[esi+8*ecx+88]  ; mmx3 = [x(23),x(22)]
        movq [edi+8*ecx+64],mm0  ; [y(17),y(16)] = [x(17),x(16)]
        movq [edi+8*ecx+72],mm1  ; [y(19),y(18)] = [x(19),x(18)]
        movq [edi+8*ecx+80],mm2  ; [y(21),x(20)] = [x(21),x(20)]
        movq [edi+8*ecx+88],mm3  ; [y(23),y(22)] = [x(23),x(22)]
        movq mm4,[esi+8*ecx+96]  ; mmx4 = [x(25),x(24)]
        movq mm5,[esi+8*ecx+104] ; mmx5 = [x(27),x(26)]
        movq mm6,[esi+8*ecx+112] ; mmx6 = [x(29),x(28)]
        movq mm7,[esi+8*ecx+120] ; mmx7 = [x(31),x(30)]
        movq [edi+8*ecx+96],mm4  ; [y(25),y(24)] = [x(25),x(24)]
        movq [edi+8*ecx+104],mm5 ; [y(27),y(26)] = [x(27),x(26)]
        movq [edi+8*ecx+112],mm6 ; [y(29),y(28)] = [x(29),x(28)]
        movq [edi+8*ecx+120],mm7 ; [y(31),y(30)] = [x(31),x(30)]
        add ecx,16               ; shift addressing ahead by 2 cachelines
    js bytecopyloop
    ret
MMX_copy endp


MMX_blk_pref_4KB proc uses esi edi ebp ebx dst:DWORD,src:DWORD,Len:DWORD
    mov ecx,Len         ; ecx = # of bytes to copy from x[] to y[]
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"
push ebp
    shr ecx,2                   ; ecx = # of double words to copy
    mov ebp,ecx                 ; copy # of floats to copy to ebp 
    shr ebp,10                  ; ebp = number of FULL 4KB blocks in each vector
    mov ebx,1024                ; ebx = the number of floats in 4KB
    imul ebx,ebp                ; ebx = number of floats in entire set of full 4KB blocks
    neg ebx                     ; ebx = - ebx
    add ebx,ecx                 ; ebx = ecx - ebx = # of floats that are remaining at end which
                                ; do not form a full 4KB block
    align 16                    ; align instructions to 16 byte boundary
        pushad                     ; preserve all the 32 bit registers on the stack
        or ebp,ebp                 ; if the number of 4KB blocks is less than 1 skip optimized 
        jz bypassfourkbcopyloop    ; routine for performing "copy" on multiple 4KB blocks 
        mov ecx,1024               ; ecx = number of floats in 4KB 
                                   ;
        emms                       ; empty mmx state (required on K6-2 processors)
        align 16                   ; align instruction address to 16 byte aligned location
        ;===================================================================================================
        ; BLOCK PREFETCHES MULTIPLE 4 KB BLOCKS and PERFORMS "copy" OPERATION ON THEM
        ;===================================================================================================
        sixteenkbcopyloop:             ;
            sub ecx,32                 ; shift the ->x by 2 cachelines for easier to maximize
                                       ;    the space that can be addressed before having to increment
                                       ;    ->x
            mov eax,16                 ; each block prefetch loop fetches 256 bytes or 4 cachelines
                                       ; and in 4KB there are 32 x 256 bytes to prefetch
            align 16                   ; align instruction address to 16 byte aligned location
            ;===============================================================================================
            ; BLOCK PREFETCHING A 4 KB BLOCK OF "x"
            ;===============================================================================================
            xblkprefcopyloop:          ;
                                       ; the following 4 lines fetch "x" cachelines from the end of the
                                       ; present 4KB block moving backward 4KB
                movq mm0,[esi+ecx*4+64]
                movq mm0,[esi+ecx*4]
                movq mm0,[esi+ecx*4-64]
                movq mm0,[esi+ecx*4-128]
                sub ecx,64             ; subtract from ecx 64 floats fetched 
                dec eax                ; subtract from eax 4 cachelines to be fetched
            jnz xblkprefcopyloop
            ;===============================================================================================
            add ecx,32                 ; add back the 32 bytes to ecx we subtracted above
                                       ;
            mov eax,64                 ; below we perform "copy" on 1 cachelines at a time. We just
                                       ;    block prefetched 
            align 16 ; align instruction address to 16 byte aligned location
            ;===============================================================================================
            ; PERFORMING "copy" ON A 4 KB BLOCK OF "x" and "y"
            ;===============================================================================================
            copyloop:                      ; 
                movq mm0,[esi+ecx*4]       ; mmx0 = [x(1),x(0)]
                movntq [edi+ecx*4],mm0     ; [y(1),y(0)] = [x(1),x(0)]
                movq mm1,[esi+ecx*4+8]     ; mmx1 = [x(3),x(2)]
                movntq [edi+ecx*4+8],mm1   ; [y(3),y(2)] = [x(3),x(2)]
                movq mm2,[esi+ecx*4+16]    ; mmx2 = [x(5),x(4)]
                movntq [edi+ecx*4+16],mm2  ; [y(5),y(4)] = [x(5),x(4)]
                movq mm3,[esi+ecx*4+24]    ; mmx3 = [x(7),x(6)]
                movntq [edi+ecx*4+24],mm3  ; [y(7),y(6)] = [x(7),x(6)]
                movq mm4,[esi+ecx*4+32]    ; mmx4 = [x(9),x(8)]
                movntq [edi+ecx*4+32],mm4  ; [y(9),y(8)] = [x(9),x(8)]
                movq mm5,[esi+ecx*4+40]    ; mmx5 = [x(11),x(10)]
                movntq [edi+ecx*4+40],mm5  ; [y(11),y(10)] = [x(11),x(10)]
                movq mm6,[esi+ecx*4+48]    ; mmx6 = [x(13),x(12)]
                movntq [edi+ecx*4+48],mm6  ; [y(13),y(12)] = [x(13),x(12)]
                movq mm7,[esi+ecx*4+56]    ; mmx7 = [x(15),x(14)]
                movntq [edi+ecx*4+56],mm7  ; [y(15),y(14)] = [x(15),x(14)]
                add ecx,16                 ; increment ecx by 1 cacheline
                dec eax                    ; dec # of 128byte blocks to perform "copy" on
            jnz copyloop                   ;
            ;===============================================================================================
            add ecx,1024               ; increment ecx by 1024 to move the addressing of "x" and "y" 
                                       ;    to the next 4KB block
            dec ebp                    ; decrement the number of 4KB blocks to perform "copy" upon
;jnz fourkbcopyloop  ; ERROR, label does not exist!!
        jnz xblkprefcopyloop    ; none work!!
        ;===================================================================================================
        sub ecx,1024               ; subtract off of ecx the 1024 added above
        imul ecx,4                 ; ecx = 4 * ecx = # of bytes of "x" and "y" copy'd already 
        add esi,ecx                ; ->x incremented to the 1st element of non full 4KB block 
                                   ; to be "copy'd"
        add edi,ecx                ; ->y incremented to the 1st element of non full 4KB block 
                                   ; to be "copy'd"
        ;===================================================================================================
        bypassfourkbcopyloop:
        mov eax,ebx                ; ebx = # of floats in non-full 4KB block
        shr eax,4                  ; eax = # of cachelines of floats in non-full 4KB block
        mov ebp,eax                ;
        imul ebp,16                ; ebp = # of floats in full cachelines of non-full 4KB block
        sub ebx,ebp                ; ebx = # of floats in non-full 4KB block that are not in full cachelines
        mov ecx,0                  ; move 0 into ecx 
        cmp eax,0                  ; check to see if the number of full cachelines is 0 and if
        jz copyfinished            ;
                                   ;
        mov ecx,eax                ; ecx = # of full cachelines
        imul ecx,16                ; ecx = # of floats in full cachelines of last 4KB block that's not full
        align 16                   ; align instruction address to 16 byte aligned location
        ;===============================================================================================
        ; BLOCK PREFETCHING REMAINING FULL CACHELINES OF "x"
        ;===============================================================================================
        copyleftoverblkpref:
            movq mm0,QWORD PTR[esi+ecx*4-64]
            sub ecx,16                 ; decrement # of floats to be prefetched by 16 or 1 cacheline
        jnz copyleftoverblkpref
        ;===================================================================================================
        align 16                   ; align instruction address to 16 byte aligned location
        ;===============================================================================================
        ; PERFORMING "copy" ON REMAINING FULL CACHELINES OF "x" and "y"
        ;===============================================================================================
        copyleftoverloop:
            movq mm0,QWORD PTR[esi+ecx*4]
            movq mm1,QWORD PTR[esi+ecx*4+8]
            movq mm2,QWORD PTR[esi+ecx*4+16]
            movq mm3,QWORD PTR[esi+ecx*4+24]
            movq mm4,QWORD PTR[esi+ecx*4+32]
            movq mm5,QWORD PTR[esi+ecx*4+40]
            movq mm6,QWORD PTR[esi+ecx*4+48]
            movq mm7,QWORD PTR[esi+ecx*4+56]
            movntq QWORD PTR[edi+ecx*4],mm0
            movntq QWORD PTR[edi+ecx*4+8],mm1
            movntq QWORD PTR[edi+ecx*4+16],mm2
            movntq QWORD PTR[edi+ecx*4+24],mm3
            movntq QWORD PTR[edi+ecx*4+32],mm4
            movntq QWORD PTR[edi+ecx*4+40],mm5
            movntq QWORD PTR[edi+ecx*4+48],mm6
            movntq QWORD PTR[edi+ecx*4+56],mm7
            add ecx,16                   ; increment addressing of "x" and "y" by 1 cacheline
            dec eax                      ; decrement # of cachelines to perform "copy" on by 1
        jnz copyleftoverloop
        ;===============================================================================================
        jmp copyfinished ; jump to condition below to perform "copy" on remaining 
        ; floats 
        ;===============================================================================================
        ; PERFORMING COPY on those elements of "x" that do not lie in full cachelines
        ;===============================================================================================
        copylastloop:
        movq mm0,QWORD PTR[esi+ecx*4]
        movntq QWORD PTR[edi+ecx*4],mm0
        add ecx,1
        dec ebx
        copyfinished:
        or ebx,ebx
        jnz copylastloop
        ;===============================================================================================
        ;sfence                       ; serialize store operations
        ;emms                         ; empty mmx state (required on K6-2 processors)
pop ebp
    ret
MMX_blk_pref_4KB endp


MMX_blk_pref_16KB proc uses esi edi ebp ebx dst:DWORD,src:DWORD,Len:DWORD
    mov ecx,Len         ; ecx = # of bytes to copy from x[] to y[]
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"
    mov edx,1
    ;mov edx,DWORD PTR[ebp+12]   ; edx = # of times to perform copy
    ;mov esi,DWORD PTR[ebp+16]   ; esi -> x
    ;mov edi,DWORD PTR[ebp+20]   ; edi -> y
    ;mov ecx,DWORD PTR[ebp+8]    ; ecx -> size
    push ebp                    ; push ebp onto stack
                                ;
    shr ecx,2                   ; ecx = # of double words to copy
    mov ebp,ecx                 ; copy # of floats to copy to ebp 
    shr ebp,12                  ; ebp = number of FULL 16KB blocks in each vector
    mov ebx,4096                ; ebx = the number of floats in 16KB
    imul ebx,ebp                ; ebx = number of floats in entire set of full 16KB blocks
    neg ebx                     ; ebx = - ebx
    add ebx,ecx                 ; ebx = ecx - ebx = # of floats that are remaining at end which
                                ; do not form a full 16KB block
    align 16                    ; align instructions to 16 byte boundary
    ;===================================================================================================
    repeat_measurement:         ; loop over the vector copy by "num_times_to_repeat" times
    ;===================================================================================================
        pushad                     ; preserve all the 32 bit registers on the stack
        or ebp,ebp                 ; if the number of 16KB blocks is less than 1 skip optimized 
        jz bypasssixteenkbcopyloop ; routine for performing "copy" on multiple 16KB blocks 
        mov ecx,4096               ; ecx = number of floats in 16KB 
                                   ;
        emms                       ; empty mmx state (required on K6-2 processors)
        align 16                   ; align instruction address to 16 byte aligned location
        ;===================================================================================================
        ; BLOCK PREFETCHES MULTIPLE 16 KB BLOCKS and PERFORMS "copy" OPERATION ON THEM
        ;===================================================================================================
        sixteenkbcopyloop:             ;
            sub ecx,32                 ; shift the ->x by 2 cachelines for easier to maximize
                                       ;    the space that can be addressed before having to increment
                                       ;    ->x
            mov eax,64                 ; each block prefetch loop fetches 256 bytes or 4 cachelines
                                       ; and in 16KB there are 32 x 256 bytes to prefetch
            align 16                   ; align instruction address to 16 byte aligned location
            ;===============================================================================================
            ; BLOCK PREFETCHING A 16 KB BLOCK OF "x"
            ;===============================================================================================
            xblkprefcopyloop:          ;
                                       ; the following 4 lines fetch "x" cachelines from the end of the
                                        ;     present 16KB block moving backward 16KB
                movq mm0,[esi+ecx*4+64]
                movq mm0,[esi+ecx*4]
                movq mm0,[esi+ecx*4-64]
                movq mm0,[esi+ecx*4-128]
                sub ecx,64             ; subtract from ecx 64 floats fetched 
                dec eax                ; subtract from eax 4 cachelines to be fetched
            jnz xblkprefcopyloop
            ;===============================================================================================
            add ecx,32                 ; add back the 32 bytes to ecx we subtracted above
                                       ;
            mov eax,256                ; below we perform "copy" on 1 cachelines at a time. We just
                                       ; block prefetched 
            align 16                   ; align instruction address to 16 byte aligned location
            ;===============================================================================================
            ; PERFORMING "copy" ON A 16 KB BLOCK OF "x" and "y"
            ;===============================================================================================
            copyloop:                      ; 
                movq mm0,[esi+ecx*4]       ; mmx0 = [x(1),x(0)]
                movntq [edi+ecx*4],mm0     ; [y(1),y(0)] = [x(1),x(0)]
                movq mm1,[esi+ecx*4+8]     ; mmx1 = [x(3),x(2)]
                movntq [edi+ecx*4+8],mm1   ; [y(3),y(2)] = [x(3),x(2)]
                movq mm2,[esi+ecx*4+16]    ; mmx2 = [x(5),x(4)]
                movntq [edi+ecx*4+16],mm2  ; [y(5),y(4)] = [x(5),x(4)]
                movq mm3,[esi+ecx*4+24]    ; mmx3 = [x(7),x(6)]
                movntq [edi+ecx*4+24],mm3  ; [y(7),y(6)] = [x(7),x(6)]
                movq mm4,[esi+ecx*4+32]    ; mmx4 = [x(9),x(8)]
                movntq [edi+ecx*4+32],mm4  ; [y(9),y(8)] = [x(9),x(8)]
                movq mm5,[esi+ecx*4+40]    ; mmx5 = [x(11),x(10)]
                movntq [edi+ecx*4+40],mm5  ; [y(11),y(10)] = [x(11),x(10)]
                movq mm6,[esi+ecx*4+48]    ; mmx6 = [x(13),x(12)]
                movntq [edi+ecx*4+48],mm6  ; [y(13),y(12)] = [x(13),x(12)]
                movq mm7,[esi+ecx*4+56]    ; mmx7 = [x(15),x(14)]
                movntq [edi+ecx*4+56],mm7  ; [y(15),y(14)] = [x(15),x(14)]
                add ecx,16                 ; increment ecx by 1 cacheline
                dec eax                    ; dec # of 128byte blocks to perform "copy" on
            jnz copyloop                   ;
            ;===============================================================================================
            add ecx,4096               ; increment ecx by 4096 to move the addressing of "x" and "y" 
                                       ;     to the next 16KB block
            dec ebp                    ; decrement the number of 16KB blocks to perform "copy" upon
        jnz sixteenkbcopyloop
        ;===================================================================================================
        sub ecx,4096               ; subtract off of ecx the 1024 added above
        imul ecx,4                 ; ecx = 4 * ecx = # of bytes of "x" and "y" copy'd already 
        add esi,ecx                ; ->x incremented to the 1st element of non full 16KB block 
                                   ; to be "copy'd"
        add edi,ecx                ; ->y incremented to the 1st element of non full 16KB block 
                                   ; to be "copy'd"
        ;===================================================================================================
        bypasssixteenkbcopyloop:
        mov eax,ebx                ; ebx = # of floats in non-full 16KB block
        shr eax,4                  ; eax = # of cachelines of floats in non-full 16KB block
        mov ebp,eax                ;
        imul ebp,16                ; ebp = # of floats in full cachelines of non-full 16KB block
        sub ebx,ebp                ; ebx = # of floats in non-full 16KB block that are not in full cachelines
        mov ecx,0                  ; move 0 into ecx 
        cmp eax,0                  ; check to see if the number of full cachelines is 0 and if
        jz copyfinished            ;
                                   ;
        mov ecx,eax                ; ecx = # of full cachelines
        imul ecx,16                ; ecx = # of floats in full cachelines of last 16KB block that's not full
        align 16                   ; align instruction address to 16 byte aligned location
        ;===============================================================================================
        ; BLOCK PREFETCHING REMAINING FULL CACHELINES OF "x"
        ;===============================================================================================
        copyleftoverblkpref:           ;
            movq mm0,QWORD PTR[esi+ecx*4-64]
            sub ecx,16                 ; decrement # of floats to be prefetched 
        jnz copyleftoverblkpref        ;    by 16 or 1 cacheline
        ;===================================================================================================
        align 16                   ; align instruction address to 16 byte aligned location
        ;===============================================================================================
        ; PERFORMING "copy" ON REMAINING FULL CACHELINES OF "x" and "y"
        ;===============================================================================================
        copyleftoverloop:
            movq mm0,QWORD PTR[esi+ecx*4]
            movq mm1,QWORD PTR[esi+ecx*4+8]
            movq mm2,QWORD PTR[esi+ecx*4+16]
            movq mm3,QWORD PTR[esi+ecx*4+24]
            movq mm4,QWORD PTR[esi+ecx*4+32]
            movq mm5,QWORD PTR[esi+ecx*4+40]
            movq mm6,QWORD PTR[esi+ecx*4+48]
            movq mm7,QWORD PTR[esi+ecx*4+56]
            movntq QWORD PTR[edi+ecx*4],mm0
            movntq QWORD PTR[edi+ecx*4+8],mm1
            movntq QWORD PTR[edi+ecx*4+16],mm2
            movntq QWORD PTR[edi+ecx*4+24],mm3
            movntq QWORD PTR[edi+ecx*4+32],mm4
            movntq QWORD PTR[edi+ecx*4+40],mm5
            movntq QWORD PTR[edi+ecx*4+48],mm6
            movntq QWORD PTR[edi+ecx*4+56],mm7
            add ecx,16                   ; increment addressing of "x" and "y" by 1 cacheline
            dec eax                      ; decrement # of cachelines to perform "copy" on by 1
        jnz copyleftoverloop
        ;===============================================================================================
        jmp copyfinished ; jump to condition below to perform "copy" on remaining 
        ; floats 
        ;===============================================================================================
        ; PERFORMING COPY on those elements of "x" that do not lie in full cachelines
        ;===============================================================================================
        copylastloop:
        movq mm0,QWORD PTR[esi+ecx*4]
        movntq QWORD PTR[edi+ecx*4],mm0
        add ecx,1
        dec ebx
        copyfinished:
        or ebx,ebx
        jnz copylastloop
        ;===============================================================================================
        sfence                       ; serialize store operations
        emms                         ; empty mmx state (required on K6-2 processors)
        popad                        ; restore all 32 bit registers from stack 
        dec edx                      ; decrement the # of times to repeat copy test
                                     ;     if eax =0 then the zero flags bit is set. 
    jnz repeat_measurement           ; if the bit is not set then loop back above to 
    ;===============================================================================================
    pop ebp                          ; restore ebp 
                                     ;    
    
    ret
MMX_blk_pref_16KB endp


MMXw3DNowPref_copy proc uses esi edi dst:DWORD,src:DWORD,Len:DWORD
    mov ecx,Len         ; ecx = # of bytes to copy from x[] to y[]
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"

    emms                 ; empty mmx state
    add esi,ecx          ; esi ->the end of the last element of x to be copied
    add edi,ecx          ; edi ->the end of the last element of y to be copied
    shr ecx,3            ; divide the number of bytes to copy by 8 to figure
                         ; out how many quad words are to be copied 
    neg ecx              ;
align 16                 ; align instructions to 16 byte boundary
bytecopyloop:                    ; copy 128 bytes of x[] to y[] with each pass through the code below
        prefetch [esi+8*ecx+1024]; prefetch 16 elements of x[] 256 bytes ahead of
        prefetch [esi+8*ecx+1088];    [esi+8*ecx]
        movq mm0,[esi+8*ecx]     ; mmx0 = [x(1),x(0)]
        movq mm1,[esi+8*ecx+8]   ; mmx1 = [x(3),x(2)]
        movq mm2,[esi+8*ecx+16]  ; mmx2 = [x(5),x(4)]
        movq mm3,[esi+8*ecx+24]  ; mmx3 = [x(7),x(6)]
        movq [edi+8*ecx],mm0     ; [y(1),y(0)] = [x(1),x(0)]
        movq [edi+8*ecx+8],mm1   ; [y(3),y(2)] = [x(3),x(2)]
        movq [edi+8*ecx+16],mm2  ; [y(5),x(4)] = [x(5),x(4)]
        movq [edi+8*ecx+24],mm3  ; [y(7),y(6)] = [x(7),x(6)]
        movq mm4,[esi+8*ecx+32]  ; mmx4 = [x(9),x(8)]
        movq mm5,[esi+8*ecx+40]  ; mmx5 = [x(11),x(10)]
        movq mm6,[esi+8*ecx+48]  ; mmx6 = [x(13),x(12)]
        movq mm7,[esi+8*ecx+56]  ; mmx7 = [x(15),x(14)]
        movq [edi+8*ecx+32],mm4  ; [y(9),y(8)] = [x(9),x(8)]
        movq [edi+8*ecx+40],mm5  ; [y(11),y(10)] = [x(11),x(10)]
        movq [edi+8*ecx+48],mm6  ; [y(13),y(12)] = [x(13),x(12)]
        movq [edi+8*ecx+56],mm7  ; [y(15),y(14)] = [x(15),x(14)]
        prefetch [esi+8*ecx+512] ; prefetch 16 elements of x[] 256 bytes ahead of
        prefetch [esi+8*ecx+576] ;    [esi+8*ecx]
        movq mm0,[esi+8*ecx+64]  ; mmx0 = [x(17),x(16)]
        movq mm1,[esi+8*ecx+72]  ; mmx1 = [x(19),x(18)]
        movq mm2,[esi+8*ecx+80]  ; mmx2 = [x(21),x(20)]
        movq mm3,[esi+8*ecx+88]  ; mmx3 = [x(23),x(22)]
        movq [edi+8*ecx+64],mm0  ; [y(17),y(16)] = [x(17),x(16)]
        movq [edi+8*ecx+72],mm1  ; [y(19),y(18)] = [x(19),x(18)]
        movq [edi+8*ecx+80],mm2  ; [y(21),x(20)] = [x(21),x(20)]
        movq [edi+8*ecx+88],mm3  ; [y(23),y(22)] = [x(23),x(22)]
        movq mm4,[esi+8*ecx+96]  ; mmx4 = [x(25),x(24)]
        movq mm5,[esi+8*ecx+104] ; mmx5 = [x(27),x(26)]
        movq mm6,[esi+8*ecx+112] ; mmx6 = [x(29),x(28)]
        movq mm7,[esi+8*ecx+120] ; mmx7 = [x(31),x(30)]
        movq [edi+8*ecx+96],mm4  ; [y(25),y(24)] = [x(25),x(24)]
        movq [edi+8*ecx+104],mm5 ; [y(27),y(26)] = [x(27),x(26)]
        movq [edi+8*ecx+112],mm6 ; [y(29),y(28)] = [x(29),x(28)]
        movq [edi+8*ecx+120],mm7 ; [y(31),y(30)] = [x(31),x(30)]
        add ecx,16               ; shift addressing ahead by 2 cachelines
    js bytecopyloop              ;
    emms                         ; empty mmx state
    ret
MMXw3DNowPref_copy endp


MMXwSSEPref_copy proc uses esi edi dst:DWORD,src:DWORD,Len:DWORD
    mov ecx,Len         ; ecx = # of bytes to copy from x[] to y[]
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"
    emms                ; empty mmx state
    add esi,ecx         ; esi ->the end of the last element of x to be copied
    add edi,ecx         ; edi ->the end of the last element of y to be copied
    shr ecx,3           ; divide the number of bytes to copy by 8 to figure
                        ; out how many quad words are to be copied
    neg ecx             ;
align 16                ; align instructions to 16 byte boundary
bytecopyloop:                        ; copy 128 bytes of x[] to y[] with each pass through the code below
        prefetchnta [esi+8*ecx+1024] ; prefetch 16 elements of x[] 256 bytes ahead of
        prefetchnta [esi+8*ecx+1088] ;    [esi+8*ecx]
        movq mm0,[esi+8*ecx]        ; mmx0 = [x(1),x(0)]
        movq mm1,[esi+8*ecx+8]      ; mmx1 = [x(3),x(2)]
        movq mm2,[esi+8*ecx+16]     ; mmx2 = [x(5),x(4)]
        movq mm3,[esi+8*ecx+24]     ; mmx3 = [x(7),x(6)]
        movq [edi+8*ecx],mm0        ; [y(1),y(0)] = [x(1),x(0)]
        movq [edi+8*ecx+8],mm1      ; [y(3),y(2)] = [x(3),x(2)]
        movq [edi+8*ecx+16],mm2     ; [y(5),x(4)] = [x(5),x(4)]
        movq [edi+8*ecx+24],mm3     ; [y(7),y(6)] = [x(7),x(6)]
        movq mm4,[esi+8*ecx+32]     ; mmx4 = [x(9),x(8)]
        movq mm5,[esi+8*ecx+40]     ; mmx5 = [x(11),x(10)]
        movq mm6,[esi+8*ecx+48]     ; mmx6 = [x(13),x(12)]
        movq mm7,[esi+8*ecx+56]     ; mmx7 = [x(15),x(14)]
        movq [edi+8*ecx+32],mm4     ; [y(9),y(8)] = [x(9),x(8)]
        movq [edi+8*ecx+40],mm5     ; [y(11),y(10)] = [x(11),x(10)]
        movq [edi+8*ecx+48],mm6     ; [y(13),y(12)] = [x(13),x(12)]
        movq [edi+8*ecx+56],mm7     ; [y(15),y(14)] = [x(15),x(14)]
        prefetchnta [esi+8*ecx+512] ; prefetch 16 elements of x[] 256 bytes ahead of
        prefetchnta [esi+8*ecx+576] ;    [esi+8*ecx]
        movq mm0,[esi+8*ecx+64]     ; mmx0 = [x(17),x(16)]
        movq mm1,[esi+8*ecx+72]     ; mmx1 = [x(19),x(18)]
        movq mm2,[esi+8*ecx+80]     ; mmx2 = [x(21),x(20)]
        movq mm3,[esi+8*ecx+88]     ; mmx3 = [x(23),x(22)]
        movq [edi+8*ecx+64],mm0     ; [y(17),y(16)] = [x(17),x(16)]
        movq [edi+8*ecx+72],mm1     ; [y(19),y(18)] = [x(19),x(18)]
        movq [edi+8*ecx+80],mm2     ; [y(21),x(20)] = [x(21),x(20)]
        movq [edi+8*ecx+88],mm3     ; [y(23),y(22)] = [x(23),x(22)]
        movq mm4,[esi+8*ecx+96]     ; mmx4 = [x(25),x(24)]
        movq mm5,[esi+8*ecx+104]    ; mmx5 = [x(27),x(26)]
        movq mm6,[esi+8*ecx+112]    ; mmx6 = [x(29),x(28)]
        movq mm7,[esi+8*ecx+120]    ; mmx7 = [x(31),x(30)]
        movq [edi+8*ecx+96],mm4     ; [y(25),y(24)] = [x(25),x(24)]
        movq [edi+8*ecx+104],mm5    ; [y(27),y(26)] = [x(27),x(26)]
        movq [edi+8*ecx+112],mm6    ; [y(29),y(28)] = [x(29),x(28)]
        movq [edi+8*ecx+120],mm7    ; [y(31),y(30)] = [x(31),x(30)]
        add ecx,16                  ; shift addressing ahead by 2 cachelines
    js bytecopyloop                 ;
    emms                   ; empty mmx state
    ret
MMXwSSEPref_copy endp


SSE_copy proc uses esi edi dst:DWORD,src:DWORD,Len:DWORD
    mov ecx,Len         ; ecx = # of bytes to copy from x[] to y[]
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"
    add esi,ecx         ; esi ->the end of the last element of x to be copied
    add edi,ecx         ; edi ->the end of the last element of y to be copied
    shr ecx,3           ; divide the number of bytes to copy by 8 to figure
                        ; out how many quad words are to be copied
    neg ecx             ;
align 16                ; align instructions to 16 byte boundary
bytecopyloop:                         ; copy 128 bytes of x[] to y[] with each pass
        movaps xmm0,[esi+8*ecx]       ; xmm0 = [x(3),x(2),x(1),x(0)]
        movaps xmm1,[esi+8*ecx+16]    ; xmm1 = [x(7),x(6),x(5),x(4)]
        movaps xmm2,[esi+8*ecx+32]    ; xmm2 = [x(11),x(10),x(9),x(8)]
        movaps xmm3,[esi+8*ecx+48]    ; xmm3 = [x(15),x(14),x(13),x(12)]
        movntps [edi+8*ecx],xmm0      ; [y(3),y(2),y(1),y(0)] = [x(3),x(2),x(1),x(0)]
        movntps [edi+8*ecx+16],xmm1   ; [y(7),y(6),y(3),y(2)] = [x(7),x(6),x(5),x(4)]
        movntps [edi+8*ecx+32],xmm2   ; [y(11),y(10),y(5),x(4)] = [x(11),x(10),x(9),x(8)]
        movntps [edi+8*ecx+48],xmm3   ; [y(15),y(14),y(7),y(6)] = [x(15),x(14),x(13),x(12)]
        movaps xmm4,[esi+8*ecx+64]    ; xmm4 = [x(19),x(18),x(17),x(16)]
        movaps xmm5,[esi+8*ecx+80]    ; xmm5 = [x(23),x(22),x(21),x(20)]
        movaps xmm6,[esi+8*ecx+96]    ; xmm6 = [x(27),x(26),x(25),x(24)]
        movaps xmm7,[esi+8*ecx+112]   ; xmm7 = [x(31),x(30),x(29),x(28)]
        movntps [edi+8*ecx+64],xmm4   ; [y(19),y(18),y(17),y(16)] = [x(19),x(18),x(17),x(16)]
        movntps [edi+8*ecx+80],xmm5   ; [y(23),y(22),y(21),y(20)] = [x(23),x(22),x(21),x(20)]
        movntps [edi+8*ecx+96],xmm6   ; [y(27),y(26),y(25),y(24)] = [x(27),x(26),x(25),x(24)]
        movntps [edi+8*ecx+112],xmm7  ; [y(31),y(30),y(29),y(28)] = [x(31),x(30),x(29),x(28)]
        add ecx,16                    ;
    js bytecopyloop                   ;
    ret
SSE_copy endp


SSE_blk_prf_4KB proc uses esi edi dst:DWORD,src:DWORD,Len:DWORD
    mov ecx,Len         ; ecx = # of bytes to copy from x[] to y[]
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"

;mov edx,DWORD PTR[ebp+12]    ; edx = # of times to perform copy
mov edx,1
;mov esi,DWORD PTR[ebp+16]    ; esi -> x
;mov edi,DWORD PTR[ebp+20]    ; edi -> y
;mov ecx,DWORD PTR[ebp+8]     ; ecx -> size
push ebp                     ; push ebp onto stack
                             ;
shr ecx,2                    ; ecx = # of double words to copy
mov ebp,ecx                  ; copy # of floats to copy to ebp 
shr ebp,10                   ; ebp = number of FULL 4KB blocks in each vector
mov ebx,1024                 ; ebx = the number of floats in 4KB
imul ebx,ebp                 ; ebx = number of floats in entire set of full 4KB blocks
neg ebx                      ; ebx = - ebx
add ebx,ecx                  ; ebx = ecx - ebx = # of floats that are remaining at end which
                             ;    do not form a full 4KB block
align 16                     ; align instructions to 16 byte boundary
;===================================================================================================
repeat_measurement:          ; loop over the vector copy by "num_times_to_repeat" times
;===================================================================================================
    pushad                       ; preserve all the 32 bit registers on the stack
                                 ;
    or ebp,ebp                   ; if the number of 4KB blocks is less than 1 skip optimized 
    jz bypassfourkbcopyloop      ; routine for performing "copy" on multiple 4KB blocks 
    mov ecx,1024                 ; ecx = number of floats in 4KB 
                                 ;
    align 16                     ; align instruction address to 16 byte aligned location
    ;===================================================================================================
    ; BLOCK PREFETCHES MULTIPLE 4 KB BLOCKS and PERFORMS "copy" OPERATION ON THEM
    ;===================================================================================================
    fourkbcopyloop:                  ;
        sub ecx,32                   ; shift the ->x by 2 cachelines for easier to maximize
                                     ;     the space that can be addressed before having to increment
                                     ;     ->x
        mov eax,16                   ; each block prefetch loop fetches 256 bytes or 4 cachelines
                                     ;     and in 4KB there are 32 x 256 bytes to prefetch
        align 16                     ; align instruction address to 16 byte aligned location
        ;===============================================================================================
        ; BLOCK PREFETCHING A 4 KB BLOCK OF "x"
        ;===============================================================================================
        xblkprefcopyloop:                ; the following 4 lines fetch "x" cachelines from the end of the
                                         ;    present 4KB block moving backward 4KB
            movaps xmm0,[esi+ecx*4+64]   ;
            movaps xmm1,[esi+ecx*4]      ;
            movaps xmm2,[esi+ecx*4-64]   ;
            movaps xmm3,[esi+ecx*4-128]  ;
            sub ecx,64                   ; subtract from ecx 64 floats fetched 
            dec eax                      ; subtract from eax 4 cachelines to be fetched
        jnz xblkprefcopyloop
        ;===============================================================================================
        add ecx,32                   ; add back the 32 bytes to ecx we subtracted above
                                     ;
        mov eax,64                   ; below we perform "copy" on 2 cachelines at a time. We just
                                     ;    block prefetched 
        align 16                     ; align instruction address to 16 byte aligned location
        ;===============================================================================================
        ; PERFORMING "copy" ON A 4 KB BLOCK OF "x" and "y"
        ;===============================================================================================
        copyloop:                        ; 
            movaps xmm0,[esi+4*ecx]      ; xmm0 = [x(3),x(2),x(1),x(0)]
            movaps xmm1,[esi+4*ecx+16]   ; xmm1 = [x(7),x(6),x(5),x(4)]
            movaps xmm2,[esi+4*ecx+32]   ; xmm2 = [x(11),x(10),x(9),x(8)]
            movaps xmm3,[esi+4*ecx+48]   ; xmm3 = [x(15),x(14),x(13),x(12)]
            movntps [edi+4*ecx],xmm0     ; [y(3),y(2),y(1),y(0)] = [x(3),x(2),x(1),x(0)]
            movntps [edi+4*ecx+16],xmm1  ; [y(7),y(6),y(3),y(2)] = [x(7),x(6),x(5),x(4)]
            movntps [edi+4*ecx+32],xmm2  ; [y(11),y(10),y(5),x(4)] = [x(11),x(10),x(9),x(8)]
            movntps [edi+4*ecx+48],xmm3  ; [y(15),y(14),y(7),y(6)] = [x(15),x(14),x(13),x(12)]
            add ecx,16                   ; increment ecx by 1 cacheline
            dec eax                      ; dec # of 128byte blocks to perform "copy" on
        jnz copyloop                     ;
        ;===============================================================================================
        add ecx,1024                 ; increment ecx by 1024 to move the addressing of "x" and "y" 
                                     ;    to the next 4KB block
        dec ebp                      ; decrement the number of 4KB blocks to perform "copy" upon
    jnz fourkbcopyloop               ;
    ;===================================================================================================
    sub ecx,1024                 ; subtract off of ecx the 1024 added above
    imul ecx,4                   ; ecx = 4 * ecx = # of bytes of "x" and "y" copy'd already 
    add esi,ecx                  ; ->x incremented to the 1st element of non full 4KB block 
                                 ;    to be "copy'd"
    add edi,ecx                  ; ->y incremented to the 1st element of non full 4KB block 
                                 ;    to be "copy'd"
    ;===================================================================================================
    bypassfourkbcopyloop:        ;
    mov eax,ebx                  ; ebx = # of floats in non-full 4KB block
    shr eax,4                    ; eax = # of cachelines of floats in non-full 4KB block
    mov ebp,eax                  ;
    imul ebp,16                  ; ebp = # of floats in full cachelines of non-full 4KB block
    sub ebx,ebp                  ; ebx = # of floats in non-full 4KB block that are not in full cachelines
    mov ecx,0                    ; move 0 into ecx 
    cmp eax,0                    ; check to see if the number of full cachelines is 0 and if
    jz copyfinished              ;
                                 ;
    mov ecx,eax                  ; ecx = # of full cachelines
    imul ecx,16                  ; ecx = # of floats in full cachelines of last 4KB block that's not full
    align 16                     ; align instruction address to 16 byte aligned location
    ;===============================================================================================
    ; BLOCK PREFETCHING REMAINING FULL CACHELINES OF "x"
    ;===============================================================================================
    copyleftoverblkpref:             ;
        movaps xmm0,QWORD PTR[esi+ecx*4-64]
        sub ecx,16                   ; decrement # of floats to be prefetched by 16 or 1 cacheline
    jnz copyleftoverblkpref          ;
    ;===================================================================================================
    align 16                     ; align instruction address to 16 byte aligned location
    ;===============================================================================================
    ; PERFORMING "copy" ON REMAINING FULL CACHELINES OF "x" and "y"
    ;===============================================================================================
    copyleftoverloop:                ;
        movaps xmm0,[esi+4*ecx]      ; xmm0 = [x(3),x(2),x(1),x(0)]
        movaps xmm1,[esi+4*ecx+16]   ; xmm1 = [x(7),x(6),x(5),x(4)]
        movaps xmm2,[esi+4*ecx+32]   ; xmm2 = [x(11),x(10),x(9),x(8)]
        movaps xmm3,[esi+4*ecx+48]   ; xmm3 = [x(15),x(14),x(13),x(12)]
        movntps [edi+4*ecx],xmm0     ; [y(3),y(2),y(1),y(0)] = [x(3),x(2),x(1),x(0)]
        movntps [edi+4*ecx+16],xmm1  ; [y(7),y(6),y(3),y(2)] = [x(7),x(6),x(5),x(4)]
        movntps [edi+4*ecx+32],xmm2  ; [y(11),y(10),y(5),x(4)] = [x(11),x(10),x(9),x(8)]
        movntps [edi+4*ecx+48],xmm3  ; [y(15),y(14),y(7),y(6)] = [x(15),x(14),x(13),x(12)]
        add ecx,16                   ; increment addressing of "x" and "y" by 1 cacheline
        dec eax                      ; decrement # of cachelines to perform "copy" on by 1
    jnz copyleftoverloop             ;
    ;===============================================================================================
    jmp copyfinished             ; jump to condition below to perform "copy" on remaining 
                                 ;    floats 
    ;===============================================================================================
    ; PERFORMING COPY on those elements of "x" that do not lie in full cachelines
    ;===============================================================================================
    copylastloop:
        movss xmm0,[esi+ecx*4]
        movss [edi+ecx*4],xmm0
        add ecx,1
        dec ebx
        copyfinished:
        or ebx,ebx
    jnz copylastloop
    ;===============================================================================================
    popad                         ; restore all 32 bit registers from stack 
    dec edx                       ; decrement the # of times to repeat copy test
                                  ;    if eax = 0 then the zero flags bit is set. 
jnz repeat_measurement            ; if the bit is not set then loop back above to 
;===============================================================================================
pop ebp                       ; restore ebp     
    ret
SSE_blk_prf_4KB endp


SSE_blk_prf_16KB proc uses esi edi dst:DWORD,src:DWORD,Len:DWORD
    mov ecx,Len         ; ecx = # of bytes to copy from x[] to y[]
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"

;mov edx,DWORD PTR[ebp+12]    ; edx = # of times to perform copy
mov edx,1
;mov esi,DWORD PTR[ebp+16]    ; esi -> x
;mov edi,DWORD PTR[ebp+20]    ; edi -> y
;mov ecx,DWORD PTR[ebp+8]     ; ecx -> size
push ebp                     ; push ebp onto stack
                             ;
shr ecx,2                    ; ecx = # of double words to copy
mov ebp,ecx                  ; copy # of floats to copy to ebp 
shr ebp,12                   ; ebp = number of FULL 16KB blocks in each vector
mov ebx,4096                 ; ebx = the number of floats in 16KB
imul ebx,ebp                 ; ebx = number of floats in entire set of full 16KB blocks
neg ebx                      ; ebx = - ebx
add ebx,ecx                  ; ebx = ecx - ebx = # of floats that are remaining at end which
                             ;    do not form a full 16KB block
align 16                     ; align instructions to 16 byte boundary
;===================================================================================================
repeat_measurement:          ; loop over the vector copy by "num_times_to_repeat" times
;===================================================================================================
    pushad                       ; preserve all the 32 bit registers on the stack
                                 ;
    or ebp,ebp                   ; if the number of 16KB blocks is less than 1 skip optimized 
    jz bypasssixteenkbcopyloop   ; routine for performing "copy" on multiple 16KB blocks 
    mov ecx,4096                 ; ecx = number of floats in 16KB 
                                 ;
    align 16                     ; align instruction address to 16 byte aligned location
    ;===================================================================================================
    ; BLOCK PREFETCHES MULTIPLE 16 KB BLOCKS and PERFORMS "copy" OPERATION ON THEM
    ;===================================================================================================
    sixteenkbcopyloop:               ;
        sub ecx,32                   ; shift the ->x by 2 cachelines for easier to maximize
                                     ;     the space that can be addressed before having to increment
                                     ;     ->x
        mov eax,64                   ; each block prefetch loop fetches 256 bytes or 4 cachelines
                                     ;     and in 16KB there are 32 x 256 bytes to prefetch
        align 16                     ; align instruction address to 16 byte aligned location
        ;===============================================================================================
        ; BLOCK PREFETCHING A 16 KB BLOCK OF "x"
        ;===============================================================================================
        xblkprefcopyloop:                ; the following 4 lines fetch "x" cachelines from the end of the
                                         ;    present 16KB block moving backward 16KB
            movaps xmm0,[esi+ecx*4+64]   ;
            movaps xmm1,[esi+ecx*4]      ;
            movaps xmm2,[esi+ecx*4-64]   ;
            movaps xmm3,[esi+ecx*4-128]  ;
            sub ecx,64                   ; subtract from ecx 64 floats fetched 
            dec eax                      ; subtract from eax 4 cachelines to be fetched
        jnz xblkprefcopyloop
        ;===============================================================================================
        add ecx,32                   ; add back the 32 bytes to ecx we subtracted above
                                     ;
        mov eax,256                  ; below we perform "copy" on 2 cachelines at a time. We just
                                     ;    block prefetched 
        align 16                     ; align instruction address to 16 byte aligned location
        ;===============================================================================================
        ; PERFORMING "copy" ON A 16 KB BLOCK OF "x" and "y"
        ;===============================================================================================
        copyloop:                        ; 
            movaps xmm0,[esi+4*ecx]      ; xmm0 = [x(3),x(2),x(1),x(0)]
            movaps xmm1,[esi+4*ecx+16]   ; xmm1 = [x(7),x(6),x(5),x(4)]
            movaps xmm2,[esi+4*ecx+32]   ; xmm2 = [x(11),x(10),x(9),x(8)]
            movaps xmm3,[esi+4*ecx+48]   ; xmm3 = [x(15),x(14),x(13),x(12)]
            movntps [edi+4*ecx],xmm0     ; [y(3),y(2),y(1),y(0)] = [x(3),x(2),x(1),x(0)]
            movntps [edi+4*ecx+16],xmm1  ; [y(7),y(6),y(3),y(2)] = [x(7),x(6),x(5),x(4)]
            movntps [edi+4*ecx+32],xmm2  ; [y(11),y(10),y(5),x(4)] = [x(11),x(10),x(9),x(8)]
            movntps [edi+4*ecx+48],xmm3  ; [y(15),y(14),y(7),y(6)] = [x(15),x(14),x(13),x(12)]
            add ecx,16                   ; increment ecx by 1 cacheline
            dec eax                      ; dec # of 128byte blocks to perform "copy" on
        jnz copyloop                     ;
        ;===============================================================================================
        add ecx,4096                 ; increment ecx by 4096 to move the addressing of "x" and "y" 
                                     ;    to the next 16KB block
        dec ebp                      ; decrement the number of 16KB blocks to perform "copy" upon
    jnz sixteenkbcopyloop            ;
    ;===================================================================================================
    sub ecx,4096                 ; subtract off of ecx the 4096 added above
    imul ecx,4                   ; ecx = 4 * ecx = # of bytes of "x" and "y" copy'd already 
    add esi,ecx                  ; ->x incremented to the 1st element of non full 16KB block 
                                 ;    to be "copy'd"
    add edi,ecx                  ; ->y incremented to the 1st element of non full 16KB block 
                                 ;    to be "copy'd"
    ;===================================================================================================
    bypasssixteenkbcopyloop:     ;
    mov eax,ebx                  ; ebx = # of floats in non-full 16KB block
    shr eax,4                    ; eax = # of cachelines of floats in non-full 16KB block
    mov ebp,eax                  ;
    imul ebp,16                  ; ebp = # of floats in full cachelines of non-full 16KB block
    sub ebx,ebp                  ; ebx = # of floats in non-full 16KB block that are not in full cachelines
    mov ecx,0                    ; move 0 into ecx 
    cmp eax,0                    ; check to see if the number of full cachelines is 0 and if
    jz copyfinished              ;
                                 ;
    mov ecx,eax                  ; ecx = # of full cachelines
    imul ecx,16                  ; ecx = # of floats in full cachelines of last 16KB block that's not full
    align 16                     ; align instruction address to 16 byte aligned location
    ;===============================================================================================
    ; BLOCK PREFETCHING REMAINING FULL CACHELINES OF "x"
    ;===============================================================================================
    copyleftoverblkpref:             ;
        movaps xmm0,QWORD PTR[esi+ecx*4-64]
        sub ecx,16                   ; decrement # of floats to be prefetched by 16 or 1 cacheline
    jnz copyleftoverblkpref          ;
    ;===================================================================================================
    align 16                     ; align instruction address to 16 byte aligned location
    ;===============================================================================================
    ; PERFORMING "copy" ON REMAINING FULL CACHELINES OF "x" and "y"
    ;===============================================================================================
    copyleftoverloop:                ;
        movaps xmm0,[esi+4*ecx]      ; xmm0 = [x(3),x(2),x(1),x(0)]
        movaps xmm1,[esi+4*ecx+16]   ; xmm1 = [x(7),x(6),x(5),x(4)]
        movaps xmm2,[esi+4*ecx+32]   ; xmm2 = [x(11),x(10),x(9),x(8)]
        movaps xmm3,[esi+4*ecx+48]   ; xmm3 = [x(15),x(14),x(13),x(12)]
        movntps [edi+4*ecx],xmm0     ; [y(3),y(2),y(1),y(0)] = [x(3),x(2),x(1),x(0)]
        movntps [edi+4*ecx+16],xmm1  ; [y(7),y(6),y(3),y(2)] = [x(7),x(6),x(5),x(4)]
        movntps [edi+4*ecx+32],xmm2  ; [y(11),y(10),y(5),x(4)] = [x(11),x(10),x(9),x(8)]
        movntps [edi+4*ecx+48],xmm3  ; [y(15),y(14),y(7),y(6)] = [x(15),x(14),x(13),x(12)]
        add ecx,16                   ; increment addressing of "x" and "y" by 1 cacheline
        dec eax                      ; decrement # of cachelines to perform "copy" on by 1
    jnz copyleftoverloop             ;
    ;===============================================================================================
    jmp copyfinished             ; jump to condition below to perform "copy" on remaining 
                                 ;    floats 
    ;===============================================================================================
    ; PERFORMING COPY on those elements of "x" that do not lie in full cachelines
    ;===============================================================================================
    copylastloop:
        movss xmm0,[esi+ecx*4]
        movss [edi+ecx*4],xmm0
        add ecx,1
        dec ebx
        copyfinished:
        or ebx,ebx
    jnz copylastloop
    ;===============================================================================================
    popad                         ; restore all 32 bit registers >from stack 
    dec edx                       ; decrement the # of times to repeat copy test
                                  ;    if eax =0 then the zero flags bit is set. 
jnz repeat_measurement            ; if the bit is not set then loop back above to 
;===============================================================================================
pop ebp                       ; restore ebp 
    ret
SSE_blk_prf_16KB endp


SSEwPref_copy proc uses esi edi dst:DWORD,src:DWORD,Len:DWORD
    mov ecx,Len         ; ecx = # of bytes to copy from x[] to y[]
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"

;mov ecx,[ebp+8]     ; ecx = # of bytes to copy from x[] to y[]
;mov eax,[ebp+12]    ; eax = number of times to perform "rep movsd" copy
mov eax,1
;mov esi,[ebp+16]    ; esi = ->"x"
;mov edi,[ebp+20]    ; edi = ->"y"
add esi,ecx         ; esi ->the end of the last element of x to be copied
add edi,ecx         ; edi ->the end of the last element of y to be copied
shr ecx,3           ; divide the number of bytes to copy by 8 to figure
                    ;    out how many quad words are to be copied from
                    ;    x[] to y[]
neg ecx             ;
align 16            ; align instructions to 16 byte boundary
;===================================================================================================
repeat_measurement: ; loop over the vector copy by "num_times_to_repeat" times
    pushad          ; push all the 32 bit registers onto the stack
    ;================================================================================================
    align 16                          ; align instructions to 16 byte boundary
    bytecopyloop:                     ; copy 128 bytes of x[] to y[] with each pass through the code below
        prefetchnta [esi+8*ecx+1024]  ; prefetch 16 elements of x[] 256 bytes ahead of
        prefetchnta [esi+8*ecx+1088]  ; [esi+8*ecx]
        movaps xmm0,[esi+8*ecx]       ; xmm0 = [x(3),x(2),x(1),x(0)]
        movaps xmm1,[esi+8*ecx+16]    ; xmm1 = [x(7),x(6),x(5),x(4)]
        movaps xmm2,[esi+8*ecx+32]    ; xmm2 = [x(11),x(10),x(9),x(8)]
        movaps xmm3,[esi+8*ecx+48]    ; xmm3 = [x(15),x(14),x(13),x(12)]
        movntps [edi+8*ecx],xmm0      ; [y(3),y(2),y(1),y(0)] = [x(3),x(2),x(1),x(0)]
        movntps [edi+8*ecx+16],xmm1   ; [y(7),y(6),y(3),y(2)] = [x(7),x(6),x(5),x(4)]
        movntps [edi+8*ecx+32],xmm2   ; [y(11),y(10),y(5),x(4)] = [x(11),x(10),x(9),x(8)]
        movntps [edi+8*ecx+48],xmm3   ; [y(15),y(14),y(7),y(6)] = [x(15),x(14),x(13),x(12)]
        movaps xmm4,[esi+8*ecx+64]    ; xmm4 = [x(19),x(18),x(17),x(16)]
        movaps xmm5,[esi+8*ecx+80]    ; xmm5 = [x(23),x(22),x(21),x(20)]
        movaps xmm6,[esi+8*ecx+96]    ; xmm6 = [x(27),x(26),x(25),x(24)]
        movaps xmm7,[esi+8*ecx+112]   ; xmm7 = [x(31),x(30),x(29),x(28)]
        movntps [edi+8*ecx+64],xmm4   ; [y(19),y(18),y(17),y(16)] = [x(19),x(18),x(17),x(16)]
        movntps [edi+8*ecx+80],xmm5   ; [y(23),y(22),y(21),y(20)] = [x(23),x(22),x(21),x(20)]
        movntps [edi+8*ecx+96],xmm6   ; [y(27),y(26),y(25),y(24)] = [x(27),x(26),x(25),x(24)]
        movntps [edi+8*ecx+112],xmm7  ; [y(31),y(30),y(29),y(28)] = [x(31),x(30),x(29),x(28)]
        add ecx,16                    ;
    js bytecopyloop                   ;
    ;===============================================================================================
    popad              ; pop old 32 bit register values off the stack
    dec eax            ; decrement the # of times to repeat copy test
                       ;    if eax =0 then the zero flags bit is set. 
jnz repeat_measurement ; if the bit is not set then loop back above to 
                       ;    "repeating:" address and repeat instructions between
                       ;    "repeating:" and "jnz repeating"     
    ret
SSEwPref_copy endp


SSE2_copy proc uses esi edi dst:DWORD,src:DWORD,Len:DWORD
    
;mov ecx,[ebp+8]     ; ecx = # of bytes to copy from x[] to y[]
;mov eax,[ebp+12]    ; eax = number of times to perform "rep movsd" copy
;mov esi,[ebp+16]    ; esi = ->"x"
;mov edi,[ebp+20]    ; edi = ->"y"
    mov ecx,Len         ; ecx = # of bytes to copy from x[] to y[]
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"
    
    add esi,ecx         ; esi ->the end of the last element of x to be copied
    add edi,ecx         ; edi ->the end of the last element of y to be copied
    shr ecx,3           ; divide the number of bytes to copy by 8 to figure
                        ;    out how many quad words are to be copied from
                        ;    x[] to y[]
    neg ecx             ;
align 16                          ; align instructions to 16 byte boundary
bytecopyloop:                     ; copy 128 bytes of x[] to y[] with each pass through the code below
        movdqa xmm0,[esi+8*ecx]       ; xmm0 = [x(3),x(2),x(1),x(0)]
        movdqa xmm1,[esi+8*ecx+16]    ; xmm1 = [x(7),x(6),x(5),x(4)]
        movdqa xmm2,[esi+8*ecx+32]    ; xmm2 = [x(11),x(10),x(9),x(8)]
        movdqa xmm3,[esi+8*ecx+48]    ; xmm3 = [x(15),x(14),x(13),x(12)]
        movntdq [edi+8*ecx],xmm0      ; [y(3),y(2),y(1),y(0)] = [x(3),x(2),x(1),x(0)]
        movntdq [edi+8*ecx+16],xmm1   ; [y(7),y(6),y(3),y(2)] = [x(7),x(6),x(5),x(4)]
        movntdq [edi+8*ecx+32],xmm2   ; [y(11),y(10),y(5),x(4)] = [x(11),x(10),x(9),x(8)]
        movntdq [edi+8*ecx+48],xmm3   ; [y(15),y(14),y(7),y(6)] = [x(15),x(14),x(13),x(12)]
        movdqa xmm4,[esi+8*ecx+64]    ; xmm4 = [x(19),x(18),x(17),x(16)]
        movdqa xmm5,[esi+8*ecx+80]    ; xmm5 = [x(23),x(22),x(21),x(20)]
        movdqa xmm6,[esi+8*ecx+96]    ; xmm6 = [x(27),x(26),x(25),x(24)]
        movdqa xmm7,[esi+8*ecx+112]   ; xmm7 = [x(31),x(30),x(29),x(28)]
        movntdq [edi+8*ecx+64],xmm4   ; [y(19),y(18),y(17),y(16)] = [x(19),x(18),x(17),x(16)]
        movntdq [edi+8*ecx+80],xmm5   ; [y(23),y(22),y(21),y(20)] = [x(23),x(22),x(21),x(20)]
        movntdq [edi+8*ecx+96],xmm6   ; [y(27),y(26),y(25),y(24)] = [x(27),x(26),x(25),x(24)]
        movntdq [edi+8*ecx+112],xmm7  ; [y(31),y(30),y(29),y(28)] = [x(31),x(30),x(29),x(28)]
        add ecx,16                    ;
    js bytecopyloop                   ;
    ret
SSE2_copy endp


SSE2wPref_copy proc uses esi edi dst:DWORD,src:DWORD,Len:DWORD
    mov ecx,Len         ; ecx = # of bytes to copy from x[] to y[]
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"
    add esi,ecx         ; esi ->the end of the last element of x to be copied
    add edi,ecx         ; edi ->the end of the last element of y to be copied
    shr ecx,3           ; divide the number of bytes to copy by 8 to figure
                        ;    out how many quad words are to be copied from
                        ;    x[] to y[]
    neg ecx             ;
    align 16            ; align instructions to 16 byte boundary
bytecopyloop:                         ; copy 128 bytes of x[] to y[] with each pass through the code below
        prefetchnta [esi+8*ecx+1024]  ; prefetch 16 elements of x[] 1024 bytes ahead of
        prefetchnta [esi+8*ecx+1088]  ;    [esi+8*ecx]
        movdqa xmm0,[esi+8*ecx]       ; xmm0 = [x(3),x(2),x(1),x(0)]
        movdqa xmm1,[esi+8*ecx+16]    ; xmm1 = [x(7),x(6),x(5),x(4)]
        movdqa xmm2,[esi+8*ecx+32]    ; xmm2 = [x(11),x(10),x(9),x(8)]
        movdqa xmm3,[esi+8*ecx+48]    ; xmm3 = [x(15),x(14),x(13),x(12)]
        movntdq [edi+8*ecx],xmm0      ; [y(3),y(2),y(1),y(0)] = [x(3),x(2),x(1),x(0)]
        movntdq [edi+8*ecx+16],xmm1   ; [y(7),y(6),y(3),y(2)] = [x(7),x(6),x(5),x(4)]
        movntdq [edi+8*ecx+32],xmm2   ; [y(11),y(10),y(5),x(4)] = [x(11),x(10),x(9),x(8)]
        movntdq [edi+8*ecx+48],xmm3   ; [y(15),y(14),y(7),y(6)] = [x(15),x(14),x(13),x(12)]
        movdqa xmm4,[esi+8*ecx+64]    ; xmm4 = [x(19),x(18),x(17),x(16)]
        movdqa xmm5,[esi+8*ecx+80]    ; xmm5 = [x(23),x(22),x(21),x(20)]
        movdqa xmm6,[esi+8*ecx+96]    ; xmm6 = [x(27),x(26),x(25),x(24)]
        movdqa xmm7,[esi+8*ecx+112]   ; xmm7 = [x(31),x(30),x(29),x(28)]
        movntdq [edi+8*ecx+64],xmm4   ; [y(19),y(18),y(17),y(16)] = [x(19),x(18),x(17),x(16)]
        movntdq [edi+8*ecx+80],xmm5   ; [y(23),y(22),y(21),y(20)] = [x(23),x(22),x(21),x(20)]
        movntdq [edi+8*ecx+96],xmm6   ; [y(27),y(26),y(25),y(24)] = [x(27),x(26),x(25),x(24)]
        movntdq [edi+8*ecx+112],xmm7  ; [y(31),y(30),y(29),y(28)] = [x(31),x(30),x(29),x(28)]
        add ecx,16                    ;
    js bytecopyloop                   ;    
    ret
SSE2wPref_copy endp

; placeholder for future incarnations
_copy proc uses esi edi dst:DWORD,src:DWORD,Len:DWORD
    mov ecx,Len         ; ecx = # of bytes to copy from x[] to y[]
    mov esi,src         ; esi = ->"x"
    mov edi,dst         ; edi = ->"y"

    ret
_copy endp
